//CtQ[GfB^version 1.12
//
//  1997 11/10 ˁ@P

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls,Math, StdCtrls,Unit2,ShellAPI;

type

  TRuleC=array[0..8]of TRadioGroup;

  TForm1 = class(TForm)
    screen: TImage;
    xZahyo: TPanel;
    yZahyo: TPanel;
    creN:   TPanel;
    ruleP:  TPanel;
    Panel1: TPanel;
    sedaiP: TPanel;
    CtrButton:   TButton;
    NextButton:  TButton;
    ClearButton: TButton;
    RandButton:  TButton;
    MsaveButton: TButton;
    MloadButton: TButton;
    SaveDialog: TSaveDialog;
    OpenDialog: TOpenDialog;
    N1: TMenuItem;
    MainMenu1: TMainMenu;
    MenuFile:  TMenuItem;
    MenuMove:  TMenuItem;
    MenuAbout: TMenuItem;
    MenuSave:  TMenuItem;
    MenuLoad:  TMenuItem;
    MenuExit:  TMenuItem;
    MenuUp:    TMenuItem;
    MenuRight: TMenuItem;
    MenuDown:  TMenuItem;
    MenuLeft:  TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure screenMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure screenMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure CtrButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure ClearButtonClick(Sender: TObject);
    procedure RandButtonClick(Sender: TObject);
    procedure MsaveButtonClick(Sender: TObject);
    procedure MloadButtonClick(Sender: TObject);
    procedure MenuClick(Sender: TObject); //j[
  private

    SaveData,workData:TData;
    wkData:TScData;
    memSaved,bt:Boolean;

    clBMP: TBitmap;
    RuleC: TRuleC; //[ݒ胉WIO[v
    RunThread:TRunThread;

    procedure clearScreen;
    procedure drawScreen;
    procedure setData;
    procedure DropFiles(var Msg:TWMDROPFILES); message WM_DROPFILES;

  public
    Data:TData;
    screenBMP:TBitmap;
  end;

var

  Form1: TForm1;

implementation
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  i,j:Integer;
begin

  screenBMP:=TBitmap.Create; //Q[ʗprbg}bv
  screenBMP.width:=481;
  screenBMP.height:=481;

  clBMP:=TBitmap.Create; // ʃrbg}bv
  clBMP.width:=481;
  clBMP.height:=481;

  clBMP.Canvas.Brush.Color:=clBlue; //ʍ쐬
  clBMP.Canvas.fillRect(Rect(0,0,480,480));

  clBMP.Canvas.pen.Color:=clWhite;

  for i:=0 to 96 do //Z`
    for j:=0 to 96 do
    begin

      clBMP.Canvas.MoveTo(j*5,0);
      clBMP.Canvas.LineTo(j*5,480);

      clBMP.Canvas.MoveTo(0,j*5);
      clBMP.Canvas.LineTo(480,j*5);

    end;

  for i:=0 to 8 do //[ݒpWIO[v쐬
  begin

    RuleC[i]:=TRadioGroup.Create(RuleP);
    RuleC[i].parent:=RuleP;
    RuleC[i].Width:=190;
    RuleC[i].Height:=32;
    RuleC[i].left:=0;
    RuleC[i].Top:=i*32;
    RuleC[i].Caption:=' '+intToStr(i);
    RuleC[i].Columns:=3;
    RuleC[i].Items.add('');
    RuleC[i].Items.add('ێ');
    RuleC[i].Items.add('');
    RuleC[i].Enabled:=True;
    RuleC[i].ItemIndex:=2;

  end;

  RuleC[2].ItemIndex:=1; //[ݒ
  RuleC[3].ItemIndex:=0;

  for i:=0 to 8 do
    Data.RuleN[i]:=RuleC[i].ItemIndex;

  clearScreen; //ʕ`

  OpenDialog.Options:=[ofFileMustExist,ofHideReadOnly];
  SaveDialog.Options:=[ofHideReadOnly,ofOverwritePrompt];

  Randomize; //񏉊

  RunThread:=TRunThread.Create(False); //XVpXbh
  RunThread.FreeOnTerminate:=True;

  DragAcceptFiles(Form1.Handle,True); // hbO

end;

procedure TForm1.clearScreen; //ʏ
begin

  screenBMP.Canvas.draw(0,0,clBMP); //Q[ʃrbg}bv
  screen.Canvas.draw(0,0,screenBMP);

  creN.Caption:=' '+intToStr(Data.n);
  sedaiP.Caption:=' '+intToStr(Data.ge);

end;

procedure TForm1.screenMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer); // }EXNbN
var
  lx,ly:Integer;
begin

  if RunThread.doing then //XVȂ߂
    Exit;

  lx:=floor(x/5); //}EXJ[\̍WZ̍Wɕϊ
  ly:=floor(y/5);

  if Data.ScData[lx,ly]=0 then //Ȃ
  begin

    Data.ScData[lx,ly]:=1; //zu
    screenBMP.Canvas.Brush.Color:=clAqua;
    Data.n:=Data.n+1; //P₷

  end
  else
  begin //łɐ

    Data.ScData[lx,ly]:=0; //
    screenBMP.Canvas.Brush.Color:=clBlue;
    Data.n:=Data.n-1; //P炷

  end;

  screenBMP.Canvas.fillRect //ΏۃZ\
        (Rect(lx*5+1,ly*5+1,lx*5+5,ly*5+5));

  Form1.screen.Canvas.draw(0,0,screenBMP);
  Form1.creN.Caption:=' '+intToStr(Data.n); //\

end;

procedure TForm1.drawScreen; // `
var
  i,j:Integer;
begin

  Data.n:=0; //NA

  for i:=0 to 95 do //JEgEʍ쐬
    for j:=0 to 95 do
    begin

      if Data.scData[j,i]=1 then //
      begin

        screenBMP.Canvas.Brush.Color:=clAqua;
        Data.n:=Data.n+1; //P₷

      end
      else
        screenBMP.Canvas.Brush.Color:=clBlue;

      if not (Data.preCell[j,i]=Data.scData[j,i]) then
        screenBMP.Canvas.fillRect(Rect(j*5+1,i*5+1,j*5+5,i*5+5));

    end;

    screen.Canvas.draw(0,0,screenBMP);

    creN.Caption:=' '+intToStr(Data.n);
    sedaiP.Caption:=' '+intToStr(Data.ge);

end;

procedure TForm1.screenMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
lx,ly:Integer;
begin //}EXJ[\ʒũZW\

  lx:=floor(x/5); //}EXJ[\̍WZ̍Wɕϊ
  ly:=floor(y/5);

  xZahyo.Caption:='X='+intToStr(lx); //Z̍W\
  yZahyo.Caption:='Y='+intToStr(ly);

end;

procedure TForm1.CtrButtonClick(Sender: TObject);
var
  i:Integer;
begin //XVE~{^

  if bt then //{^Ȃ烊^[
    Exit;

  bt:=true; //{^Jn

  if RunThread.doing then //XV
  begin

    RunThread.go:=False; //XVI
    CtrButton.Caption:='XV(&A)';

    for i:=0 to 8 do  //[ݒ胉WIO[vL
      RuleC[i].Enabled:=true;

    NextButton.Enabled:=True;
    ClearButton.Enabled:=True;
    RandButton.Enabled:=True;

    if memSaved then //LĂĐ{^L
      MloadButton.Enabled:=True;

    MsaveButton.Enabled:=True;
    MenuFile.Enabled:=True;
    MenuMove.Enabled:=True;

  end
  else
  begin //XVłȂ

    for i:=0 to 8 do
    begin

      Data.ruleN[i]:=RuleC[i].ItemIndex; //[ݒ
      RuleC[i].Enabled:=False;  //[ݒ胉WIO[v

    end;

    CtrButton.Caption:='~(&C)';

    NextButton.Enabled:=False;
    ClearButton.Enabled:=False;
    RandButton.Enabled:=False;
    MloadButton.Enabled:=False;
    MsaveButton.Enabled:=False;
    MenuFile.Enabled:=False;
    MenuMove.Enabled:=False;

    RunThread.thData:=Data;
    RunThread.go:=True; //XVJn
    DragAcceptFiles(Form1.Handle,False); // hbO~

    if RunThread.Suspended then
      RunThread.Resume;

  end;

  bt:=false; //{^I

end;

procedure TForm1.NextButtonClick(Sender: TObject);
var
  celln,i,j,i2,j2:Integer;
begin //XV

  RunThread.Suspend; //x̂߃Xbh~
  CtrButton.Enabled:=false; //XV͎XV{^

  for i:=0 to 8 do //[ݒ
    Data.ruleN[i]:=RuleC[i].ItemIndex;

  Data.preCell:=Data.ScData; //݂̐󋵂Ҕ

  for i:=0 to 95 do
    for j:=0 to 95 do
    begin

      celln:=0; //JE^NA

      for i2:=i-1 to i+1 do //ΏۃZӂ̐v
        for j2:=j-1 to j+1 do
          if (i2>0) and (i2<96) and (j2>0) and (j2<96) then
            if Data.preCell[j2,i2]=1 then
              celln:=celln+1;

      if Data.preCell[j,i]=1 then //g̕Ђ
        celln:=celln-1;

      if (Data.ruleN[celln]=0) then //[ɊÂĐ
        Data.ScData[j,i]:=1
      else if not(Data.ruleN[celln]=1) then
        Data.ScData[j,i]:=0;

  end;

  Data.ge:=Data.ge+1; //Pi߂
  drawScreen;

  CtrButton.Enabled:=true; //XV{^L
  RunThread.Resume; //XbhĊJ

end;

procedure TForm1.ClearButtonClick(Sender: TObject);
var
  i,j:Integer;
begin //Q[NA

   if not(MessageDlg('݂̃Q[j܂H', //mF
     mtWarning,mbOkCancel,0)=mrOk) then
       Exit;

  for i:=0 to 95 do //̔zu󋵂NA
    for j:=0 to 95 do
      Data.ScData[j,i]:=0;

  Data.ge:=0; //NA
  Data.n:=0;  //NA

  clearScreen; //ʏ

end;

procedure TForm1.MsaveButtonClick(Sender: TObject);
var
  i:Integer;

begin //Z[u

  for i:=0 to 8 do //݂̃[ݒL
    Data.RuleN[i]:=RuleC[i].ItemIndex;

  SaveData:=Data; //L
  MloadButton.Enabled:=true; //Đ{^L
  memSaved:=true; //Z[utOZbg

end;

procedure TForm1.MloadButtonClick(Sender: TObject);
begin //Đ{^

  Data:=SaveData;
  setData;

end;

procedure TForm1.RandButtonClick(Sender: TObject);
var
  i,rx,ry:Integer;
begin //zu

  for i:=1 to 10+Random(11) do //łPO[QO̓_߂
  begin

    rx:=Random(96);
    ry:=Random(96);

    if Data.ScData[rx,ry]=0 then //ɐȂΐVɔzu
    begin

      Data.n:=Data.n+1;
      Data.ScData[rx,ry]:=1;
      screenBMP.Canvas.Brush.Color:=clAqua;
      screenBMP.Canvas.fillRect(Rect(rx*5+1,ry*5+1,rx*5+5,ry*5+5));

      Form1.screen.Canvas.draw(0,0,screenBMP);
      Form1.creN.Caption:=' '+intToStr(Data.n);

    end;

  end;

end;

procedure TForm1.setData;
var
  i,j:Integer;
begin //݂̐ݒ`


  clearScreen;
  Data.n:=0;

  for i:=0 to 95 do //zu
    for j:=0 to 95 do
      if Data.scData[j,i]=1 then
      begin

        screenBMP.Canvas.Brush.Color:=clAqua;
        Data.n:=Data.n+1;

        screenBMP.Canvas.fillRect(Rect(j*5+1,i*5+1,j*5+5,i*5+5));

      end;

  for i:=0 to 8 do
    RuleC[i].ItemIndex:=Data.RuleN[i];

  screen.Canvas.draw(0,0,screenBMP);
  creN.Caption:=' '+intToStr(Data.n);
  sedaiP.Caption:=' '+intToStr(Data.ge);

end;

procedure TForm1.MenuClick(Sender: TObject);
var
  i,j:Integer;
  fn:String;
  datFile:File of TData;
begin //j[ICxg

  if Sender=MenuSave then //ۑ
  begin

    if SaveDialog.Execute=False then
      exit;

    fn:=SaveDialog.FileName;

    for i:=0 to 8 do
      Data.RuleN[i]:=RuleC[i].ItemIndex;

    AssignFile(datFile,fn);
    Rewrite(datFile);
    Write(datFile,Data);
    CloseFile(datFile);

    Exit;

  end;

  if Sender=MenuLoad then //ǂݍ
  begin

    if OpenDialog.Execute=False then
      Exit;

    fn:=OpenDialog.FileName;

    AssignFile(datFile,fn);
    Reset(datFile);

    try
      Read(datFile,workData);
    except
      ShowMessage('̃t@C͐ݒt@Cł͂܂B');
      CloseFile(datFile);
      exit;
    end;

    if not(Eof(datFile)) then
    begin
      ShowMessage('̃t@C͐ݒt@Cł͂܂B');
      CloseFile(datFile);
      exit;
    end;

    Data:=workData;

    CloseFile(datFile);

    setData;
    Exit;

  end;

  if Sender=MenuExit then //I
    Application.Terminate;

  if Sender=MenuUp then //ֈړ
  begin

    for i:=1 to 95 do
      for j:=0 to 95 do
        wkData[j,i]:=Data.scData[j,i];

    for i:=0 to 94 do
      for j:=0 to 95 do
        Data.scData[j,i]:=wkData[j,i+1];

    for i:=0 to 95 do
      Data.scData[i,95]:=0;

    setData;
    Exit;

  end;

  if Sender=MenuRight then //Eֈړ
  begin

    for i:=0 to 95 do
      for j:=0 to 94 do
        wkData[j,i]:=Data.scData[j,i];

    for i:=0 to 95 do
      for j:=1 to 95 do
        Data.scData[j,i]:=wkData[j-1,i];

    for i:=0 to 95 do
      Data.scData[0,i]:=0;

    setData;
    Exit;

  end;

  if Sender=MenuDown then //ֈړ
  begin

    for i:=0 to 94 do
      for j:=0 to 95 do
        wkData[j,i]:=Data.scData[j,i];

    for i:=1 to 95 do
      for j:=0 to 95 do
        Data.scData[j,i]:=wkData[j,i-1];

    for i:=0 to 95 do
      Data.scData[i,0]:=0;

    setData;
    Exit;

  end;

  if Sender=MenuLeft then //ֈړ
  begin

    for i:=0 to 95 do
      for j:=1 to 95 do
        wkData[j,i]:=Data.scData[j,i];

    for i:=0 to 95 do
      for j:=0 to 94 do
        Data.scData[j,i]:=wkData[j+1,i];

    for i:=0 to 95 do
      Data.scData[95,i]:=0;

    setData;
    Exit;

  end;

  if Sender=MenuAbout then //o[W
    ShowMessage('CtQ[GfB^ Version1.13 (C)1997-2003 ˁ@P');

end;

procedure TForm1.DropFiles(var Msg:TWMDROPFILES); // t@Chbv
var
 fn: array [0..255] of Char;
 datFile: File of TData;
begin

  DragQueryFile(Msg.Drop, 0, fn, SizeOf(fn)-1); // t@C擾

  AssignFile(datFile,fn);
  Reset(datFile);

  try
    Read(datFile,workData);
  except
    ShowMessage('̃t@C͐ݒt@Cł͂܂B');
    CloseFile(datFile);
    exit;
  end;

  if not(Eof(datFile)) then
  begin
    ShowMessage('̃t@C͐ݒt@Cł͂܂B');
    CloseFile(datFile);
    DragFinish(Msg.Drop);
    exit;
  end;

  Data:=workData;

  CloseFile(datFile);
  DragFinish(Msg.Drop);

  setData;
  Exit;

end;

procedure TForm1.FormDestroy(Sender: TObject);
var
  i:Integer;
begin //I

  RunThread.Terminate; //XbhIw

  for i:=0 to 8 do
    RuleC[i].Free;

  screenBMP.Free;
  clBMP.Free;

end;

end.
